/*
**
** !!!!Je tu BUG!!!!
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <list>
#include <iostream>
#include <iterator>
#include <stack>

#define MAXN 150000

using namespace std;

struct VERTEX2 {
    int v;   //ukazatel na suseda (v poli graph)
    list<VERTEX2>::iterator cross;  //crosslink na miesto v zozname, kde ma "v" ulozeny tento vrchol
};

ostream & operator<<(ostream &a, const VERTEX2 &v)
{
    return a<<v.v;
}

struct VERTEX {
    int color; //malo by byt zrejme z nazvu
    
    int ods; //som odstraneny?
    list<int> num; //vrcholy zkontrahovane do tohoto vrcholu
    int degree;  //stupen
    int deg11;  //ak ma stupen 5, tak deg11 == 1 iff aspon 4 susedne vrcholy maju stupen max. 11
    list<VERTEX2> sus;  //susedia

    list<int>::iterator kde;  //miesto v zozname vrcholov pre jednotlive stupne
};

VERTEX graph[MAXN];
int n, m;  //pocet vrcholov a hran

list<int> degrees[MAXN];  //zoznamy vrcholov pre jednotlive stupne
list<int> deg11;   //zoznamy vrcholov pre stupen 5, pre ktore deg11==1

//kopia grafu, aby sme ho nemuseli znovu zistovat
list<int> kopia[MAXN];

//zisti pocet  susedov vrchola co, ktore maju degrees max. 11
int susmax11(int co)
{
    list<VERTEX2>::iterator it;
    int p11;
    
    p11=0;
    for (it=graph[co].sus.begin(); it != graph[co].sus.end(); it++) {
        if (graph[it->v].degree <= 11) {
            p11++;
        }
    }

    return p11;
}

//odstran vrchol zo zoznamov stupnov
void odstranzdeg(int co) 
{
    if (graph[co].deg11==1 && graph[co].degree ==5) {
        deg11.erase(graph[co].kde);
        graph[co].kde=0;
    } else {
        degrees[graph[co].degree].erase(graph[co].kde);
        graph[co].kde=0;
    }
}

//prida vrchol do zoznamov stupnov
void pridajdeg(int co) 
{
    int p11;
    
    if (graph[co].degree == 5) {
        p11=susmax11(co);
        if (p11 >= 4) {
            deg11.push_front(co);
            graph[co].kde=deg11.begin();
            graph[co].deg11=1;
        } else {
            degrees[graph[co].degree].push_front(co);
            graph[co].kde=degrees[graph[co].degree].begin();
            graph[co].deg11=0;
        }
    } else if (graph[co].degree == 11) {
        degrees[graph[co].degree].push_front(co);
        graph[co].kde=degrees[graph[co].degree].begin();
        //!pozor, tu treba prejst vsetkcyh susedov
    } else {
        degrees[graph[co].degree].push_front(co);
        graph[co].kde=degrees[graph[co].degree].begin();
    }
}

//odstran vrchol z grafu
void zober(int co)
{
    list<VERTEX2>::iterator it, it2;
    int v,p11;
    
    graph[co].ods=1;
    for (it = graph[co].sus.begin(); it != graph[co].sus.end(); it++) {
        v=it->v;
        graph[v].sus.erase(it->cross);
        odstranzdeg(v);
        graph[v].degree--;
        pridajdeg(v);
/*        if (graph[v].degree == 11) {
            for (it2=graph[v].sus.begin(); it2 != graph[v].sus.end(); it2++) {
                if (graph[it2->v].degree == 5 && graph[it2->v].deg11 == 0) {
                    p11=susmax11(it2->v);
                    if (p11 >= 4) {
                        degrees[graph[it2->v].degree].erase(graph[it2->v].kde);
                        deg11.push_front(it2->v);
                        graph[it2->v].kde=deg11.begin();
                        graph[it2->v].deg11=1;
                    }
                }
            }
        }*/
    }
    //uprac
    for (it=graph[co].sus.begin(); it != graph[co].sus.end(); it++) {
        v=it->v;
        if (graph[v].degree == 11) {
            for (it2=graph[v].sus.begin(); it2 != graph[v].sus.end(); it2++) {
                if (graph[it2->v].degree == 5 && graph[it2->v].deg11 == 0 && it2->v != co) {
                    odstranzdeg(it2->v);
                    pridajdeg(it2->v);
                }
            }
        }
    }
}    

//mergne vrcholy a,b do vrchola a
void mergni(int a, int b)
{
    list<VERTEX2>::iterator it, it2;
    int nas,v,p11;
    
    odstranzdeg(a);
    odstranzdeg(b);
    graph[b].ods=1;
    graph[a].num.splice(graph[a].num.begin(),graph[b].num);
    for (it=graph[b].sus.begin();it != graph[b].sus.end(); it++) {
//        printf("it->v=%d\n",it->v);
        odstranzdeg(it->v);

        nas = 0;
        for (it2=graph[a].sus.begin(); it2 != graph[a].sus.end(); it2++) {
            if (it2->v == it->v) {
                nas = 1;
                break;
            }
        }
        if (nas == 0) {
            graph[a].degree++;
            graph[a].sus.push_front(*it);
            graph[a].sus.begin()->cross->cross=graph[a].sus.begin();
            graph[a].sus.begin()->cross->v=a;
        } else {
            graph[it->v].sus.erase(it->cross);
            graph[it->v].degree--;
        }
    }

    //uprac
    pridajdeg(a);
    for (it=graph[a].sus.begin();it != graph[a].sus.end(); it++) {
        if (graph[it->v].kde==0) {
            pridajdeg(it->v);
        } else {
            odstranzdeg(it->v);
            pridajdeg(it->v);
        }
        v=it->v;
        if (graph[v].degree == 11) {
            for (it2=graph[v].sus.begin(); it2 != graph[v].sus.end(); it2++) {
                if (graph[it2->v].degree == 5 && graph[it2->v].deg11 == 0) {
                    p11=susmax11(it2->v);
                    if (p11 >= 4) {
                        degrees[graph[it2->v].degree].erase(graph[it2->v].kde);
                        deg11.push_front(it2->v);
                        graph[it2->v].kde=deg11.begin();
                        graph[it2->v].deg11=1;
                    }
                }
            }
        }
    }
}

//zisti dva vrcholy stupna max. 11 susediace s v, ktore nie su navzajom susedia
void zisnesus(int v, int &a, int &b)
{
    list<VERTEX2>::iterator it, it2, it3;
    int nas;

    for (it=graph[v].sus.begin(); it != graph[v].sus.end(); it++) {
        if (graph[it->v].degree <= 11) {
            for (it2=it,it2++; it2 != graph[v].sus.end(); it2++) {
                if (graph[it2->v].degree <= 11) {
                    nas = 0;
                    for (it3=graph[it->v].sus.begin(); it3 != graph[it->v].sus.end(); it3++) {
                        if (it3->v==it2->v) {
                            nas = 1;
                            break;
                        }
                    }
                    if (nas == 0) {
                        a=it->v;
                        b=it2->v;
                        return;
                    }
                }
            }
        }
    }

    printf("vo fcii zisnesus: zle volanie funkcie. graf nie je asi planarny!!!\n");
    exit(1);
}


void pridaj_hranu(int a, int b)
{
    VERTEX2 v1, v2;

    v1.v=a; v2.v=b;
    graph[a].sus.push_front(v2); graph[b].sus.push_front(v1);
    graph[a].sus.begin()->cross=graph[b].sus.begin();
    graph[b].sus.begin()->cross=graph[a].sus.begin();
    graph[a].degree++;
    graph[b].degree++;
    return;
}

void vypis_graph()
{
    int i;
    for (i = 0; i < n; i++) {
        if (graph[i].ods==1) continue;
        printf("vrchol cislo %d: zoznam vrcholov: ", i);
        copy(graph[i].num.begin(), graph[i].num.end(), ostream_iterator<int>(cout, " "));
        printf("\n");
        printf("zoznam susedov: ");
        copy(graph[i].sus.begin(), graph[i].sus.end(), ostream_iterator<VERTEX2>(cout, " "));
        printf("\n");
        printf("deg11=%d, degree=%d\n", graph[i].deg11, graph[i].degree);
    }
}

void vypis_deg()
{
    int i;
    printf("zoznamy pre stupne:\n");
    for (i = 0; i < n; i++) {
        if (i == 5) {
            printf("11stupen=%d:",i);
            copy(deg11.begin(), deg11.end(), ostream_iterator<int>(cout, " "));
            printf("\n");
        }
        if (degrees[i].empty()) continue;
        printf("stupen=%d:",i);
        copy(degrees[i].begin(), degrees[i].end(), ostream_iterator<int>(cout, " "));
        printf("\n");
    }
}

list<int> zobr;  //zobrate vrcholy

int main()
{
  stdin = fopen("color.in", "r");
  stdout = fopen("color.out", "w");
    //fprintf(stderr,"begin...");
    int i, a, b,v,pocods;
    list<int>::iterator it, it2;
    list<VERTEX2>::iterator it3;

    int color[6];
    
    int p11;

    int nas;
    
    scanf("%d %d", &n,&m);
    //init
    for (i=0; i<n; i++) {
        graph[i].degree=0;
        graph[i].deg11=-1;
        graph[i].kde=0;
        graph[i].num.push_front(i);
        graph[i].ods=0;
        graph[i].color=-1;
    }

    //nacitaj
    for (i = 0; i < m; i++) {
        scanf("%d %d", &a, &b);
        a--;b--;
        pridaj_hranu(a,b);     
        kopia[a].push_front(b);
        kopia[b].push_front(a);
    }

//    fprintf(stderr,"ahoj\n");
//    return 0;
    //inicializuj zoznamy pre jednotlive stupne
    for (i = 0; i < n; i++) {
        if (graph[i].degree!=5) {
            degrees[graph[i].degree].push_front(i);
            graph[i].kde=degrees[graph[i].degree].begin();
        } else {
            p11=susmax11(i);
            if (p11 >= 4) {
                deg11.push_front(i);
                graph[i].kde=deg11.begin();
                graph[i].deg11=1;
            } else {
                degrees[5].push_front(i);
                graph[i].kde=deg11.begin();
                graph[i].deg11=0;
            }
        }
    }

/*   vypis_graph();
    vypis_deg();*/

    pocods=0;
    //hlavny cyklus
    while (pocods < n) {
        nas=0;
        for (i = 0; i <=4; i++) {
            if (degrees[i].empty() == 0) {
                nas=1;
                break;
            }
        }
        if (nas == 1) {
            v=*degrees[i].begin();
//            printf("%d\n",v);
            degrees[i].pop_front();
            zobr.push_front(v);
            pocods += graph[v].num.size();

//            printf("beriem v=%d\n", v);
            zober(v);
/*            printf("\n");
            vypis_graph();
            vypis_deg();
            printf("\n");*/
        } else {
            if (deg11.empty()==1) {
  //              printf("Graf nie je planarny!!! (alebo bug v programe)\n");
                return 1;
            }
            v=*deg11.begin();
 //           printf("%d\n",v);
            deg11.pop_front();
            zobr.push_front(v);
            pocods += graph[v].num.size();
            
            zisnesus(v,a,b);
/*            printf("beriem v=%d, mergujem %d,%d\n", v,a,b);
            printf("v=%d a=%d b=%d\n", v,a,b);*/

            zober(v);
/*            printf("zobral som v\n");
            printf("\n");
            vypis_graph();
            vypis_deg();
            printf("\n");*/
            mergni(a,b);
//            printf("mergol som ich\n");
        }
    }
   
/*    printf("\n");
    printf("mnoziny:\n");
    for (it = zobr.begin(); it != zobr.end(); it++) {
        copy(graph[*it].num.begin(), graph[*it].num.end(), ostream_iterator<int>(cout, " "));
        printf("\n");
    }
    printf("\n");*/
    
    for (it = zobr.begin(); it != zobr.end(); it++) {
        for (i = 1; i <= 5; i++) {
            color[i]=0;
        }
        for (it2 = graph[*it].num.begin(); it2 != graph[*it].num.end(); it2++) {
            for (it3 = graph[*it2].sus.begin(); it3 != graph[*it2].sus.end(); it3++) {
                if (graph[it3->v].color != -1) {
                    color[graph[it3->v].color]=1;
                }
            }
        }
        nas=0;
        for (i = 1; i<= 5; i++) {
            if (color[i] == 0) {
                nas = 1;
                break;
            }
        }
        if (nas == 1) {
            for (it2 = graph[*it].num.begin(); it2 != graph[*it].num.end(); it2++) {
                graph[*it2].color=i;
            }
        } else {
//            printf("Fatal error: Bug v programe. Vsetky farby su obsadene.\n");
            return 1;
        }
    }
    for (i = 0; i < n-1; i++) {
        printf("%d ", graph[i].color);
    }
    printf("%d\n", graph[n-1].color);
     
    //fprintf(stderr,"done!\n");    
    
    
    return 0;
}
